// Copyright 2022 The Android Open Source Project
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
// http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either expresso or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#include <cstdint>

#pragma once

namespace gfxstream {

// Common base struct representing images (Gl/Vk) that are borrowed
// by server components (e.g. CompositorGl, CompositorVk, DisplayVk)
// from the underlying server image owner (GlEmulation/VkEmulation).
struct BorrowedImageInfo {
    virtual ~BorrowedImageInfo() {}

    uint32_t id = 0;
    uint32_t width = 0;
    uint32_t height = 0;
};

}  // namespace gfxstream
